script SAMSARA_MARATHON (int class, int slot, int dropped, int summoned)
{
    int giveboth    = isInvasion() || !(isCoop() || isSinglePlayer());
    int hasShotty   = CheckInventory("WSTE-M5 Combat Shotgun");
    int hasBoth     = CheckInventory("CanDualShotties");
    int limited     = CheckInventory("LevelLimiter");
    int limit       = GetCVar("sv_itemrespawn") || GetCVar("sv_weaponstay");
    int ammoFull    = CheckInventory("Shell") >= (GetAmmoCapacity("Shell") / ((dropped*3)+1));
    int i;
    // The above line is because of the quadupling of ammo capacity with dropped pickups
    // It's a really gross hack. I hate it. But it works.
    
    switch (slot)
    {
      case SLOT_CHAINSAW:
        GiveInventory("CanDualPistols", 1);
        GiveInventory("KKV-7 SMG Flechette", 1);
        /*GiveInventory("Clip", 64);
        if (GetCVar("samsara_pistolammo")) { GiveInventory("Clip", 16); }*/

        if (strcmp(ClassWeapons[class][slot][S_AMMO1], ""))
        {
            i = ammoCount(ClassWeapons[class][slot][S_AMMO1]);
            GiveInventory(ClassWeapons[class][slot][S_AMMO1], i*2);
        }

        if (strcmp(ClassWeapons[class][slot][S_AMMO2], ""))
        {
            i = ammoCount(ClassWeapons[class][slot][S_AMMO2]);
            GiveInventory(ClassWeapons[class][slot][S_AMMO2], i*2);
        }

        break;
        
      case SLOT_SHOTGUN:
        /*if (limited && !dropped)
        {
            SetResultValue(0);
            terminate;
        }

        if ((dropped && hasShotty && ammoFull) ||
            (!dropped && (hasBoth || (hasShotty && limited)) && ammoFull))
        {
            SetResultValue(0);
            terminate;
        }*/
        
        GiveInventory("Shell", 8 / (!!dropped+1));
        GiveInventory("WSTE-M5 Combat Shotgun", 1);
        GiveInventory("CanDualShotties", 1);   

        /*if (giveboth || (hasShotty && !dropped))
        {
            GiveInventory("CanDualShotties", 1);
        }
        
        if (limit && !dropped)
        {
            GiveInventory("LevelLimiter", 1);
        }
        SetResultValue(1);*/
        break;

      /*case SLOT_SUPERSHOTGUN:
        GiveInventory("Fusion Pistol", 1);
        GiveInventory("Cell", 40);
        break;

      case SLOT_CHAINGUN:
        GiveInventory("MA-75B Assault Rifle", 1);
        GiveInventory("Clip", 104);
        GiveInventory("RocketAmmo", 14);
        break;

      case SLOT_ROCKETLAUNCHER:
        GiveInventory("SPNKR-XP SSM Launcher", 1);
        GiveInventory("RocketAmmo", 4);
        break;

      case SLOT_PLASMARIFLE:
        GiveInventory("TOZT-7 Napalm Unit", 1);
        GiveInventory("Cell", 420);
        break;

      case SLOT_BFG9000:
        GiveInventory("ONI-71 Wave Motion Cannon", 1);
        GiveInventory("Cell", 80);
        GiveInventory("RocketAmmo", 30);
        break;*/

      default:
        GiveInventory(ClassWeapons[class][slot][S_WEP], 1);

        if (strcmp(ClassWeapons[class][slot][S_AMMO1], ""))
        {
            i = ammoCount(ClassWeapons[class][slot][S_AMMO1]);
            GiveInventory(ClassWeapons[class][slot][S_AMMO1], i*2);
        }

        if (strcmp(ClassWeapons[class][slot][S_AMMO2], ""))
        {
            i = ammoCount(ClassWeapons[class][slot][S_AMMO2]);
            GiveInventory(ClassWeapons[class][slot][S_AMMO2], i*2);
        }

        break;
    }
}

script SAMSARA_RESONATE (int which, int frequency) clientside
{
    if (which < 0 || which >= RESCOUNT) { Log(s:"\caERROR\c- (minor): Attempted to resonate with invalid index (", d:which, s:")"); terminate; }

    int pln = PlayerNumber();
    int locktime = Timer();

    int item = ResonantItems[which][0];
    int low  = ResonantItems[which][1];
    int high = ResonantItems[which][2];

    if (frequency == 0) { Log(s:"\caERROR\c-: Attempted to resonate item \"", s:item, s:"\" with frequency of 0"); terminate; }
    frequency = abs(frequency);

    int resPosition     = random(low, high);
    int resNextPos      = resPosition;
    int resAmplitude    = 0;
    int resIndex        = 0;
    int resTimer;
    int resonance;

    ResonantTimes[pln][which] = locktime;

    while (ResonantTimes[pln][which] == locktime)
    {
        if (abs(resPosition - resNextPos) <= 2) { resPosition = resNextPos; }
        else { resPosition += (resNextPos - resPosition) / 3; }

        if (resAmplitude == 0) { resTimer = 0; }

        if (resTimer == 0)
        {
            resAmplitude += random(1.0, 20.0);
            resTimer = random(1, 70);
            resNextPos = random(low, high);
        }

        resonance = FixedMul(resAmplitude, sin(itof(resIndex) / frequency)) + itof(resPosition);
        resAmplitude = max(0, resAmplitude - 0.5);

        TakeInventory(item, 0x7FFFFFFF);
        GiveInventory(item, ftoi(resonance));

        Delay(1);
        resTimer--;
        resIndex++;
        resIndex %= (frequency * 100);
    }
}

/*script "SamsaraMarathonWeaponSkinChecker" (int weapon)
{
    int result;
    int usingNotRifle = CheckWeapon("Steel Knuckles") || CheckWeapon("SPNKR-25 Auto Cannon") || CheckWeapon(".44 Magnum Mega Class A1") || CheckWeapon("KKV-7 SMG Flechette") || CheckWeapon("Tech.50 Pacifier") || CheckWeapon("WSTE-M5 Combat Shotgun") || CheckWeapon("Fusion Pistol") || CheckWeapon("SPNKR-XP SSM Launcher") || CheckWeapon("TOZT-7 Napalm Unit") || CheckWeapon("ONI-71 Wave Motion Cannon") || CheckWeapon("Alien Weapon") || CheckWeapon(" Alien Weapon ") || CheckWeapon("Talon Ceramic Combat Blade");

    switch (weapon)
    {
      case 13:
        result = CheckWeapon("WSTE-M5 Combat Shotgun") && CheckInventory("UsingDualShotguns");
        break;

      case 12:
        result = CheckWeapon(".44 Magnum Mega Class A1") && CheckInventory("UsingDualPistols");
        break;

      case 11:
        result = CheckWeapon(" Alien Weapon ");
        break;

      case 10:
        result = CheckWeapon("Alien Weapon");
        break;

      case 9:
        result = CheckWeapon("TOZT-7 Napalm Unit");
        break;

      case 8:
        result = CheckWeapon("SPNKR-XP SSM Launcher") || CheckWeapon("ONI-71 Wave Motion Cannon");
        break;

      case 7:
        result = CheckWeapon("WSTE-M5 Combat Shotgun") && !CheckInventory("UsingDualShotguns");
        break;

      case 6:
        result = CheckWeapon("SPNKR-25 Auto Cannon");
        break;

      case 5:
        result = CheckWeapon("Fusion Pistol") || CheckWeapon("Tech.50 Pacifier");
        break;

      case 4:
        result = CheckWeapon("Steel Knuckles") || CheckWeapon("Talon Ceramic Combat Blade");
        break;

      case 3:
        result = CheckWeapon(".44 Magnum Mega Class A1") && !CheckInventory("UsingDualPistols");
        break;

      case 2:
        result = CheckWeapon("KKV-7 SMG Flechette");
        break;

      case 1:
        result = !usingNotRifle;
        break;
    }

    SetResultValue(result);
}*/

script "SamsaraMarathonWeaponSkinChecker" ENTER
{
    if (!CheckInventory("MarathonClass")) { terminate; }

    while (1)
    {
        int usingNotRifle = CheckWeapon("Steel Knuckles") || CheckWeapon("SPNKR-25 Auto Cannon") || CheckWeapon(".44 Magnum Mega Class A1") || CheckWeapon("KKV-7 SMG Flechette") || CheckWeapon("Tech.50 Pacifier") || CheckWeapon("WSTE-M5 Combat Shotgun") || CheckWeapon("Fusion Pistol") || CheckWeapon("SPNKR-XP SSM Launcher") || CheckWeapon("TOZT-7 Napalm Unit") || CheckWeapon("ONI-71 Wave Motion Cannon") || CheckWeapon("Alien Weapon") || CheckWeapon(" Alien Weapon ") || CheckWeapon("Talon Ceramic Combat Blade");

        if (CheckWeapon("WSTE-M5 Combat Shotgun") && CheckInventory("UsingDualShotguns")) { SetInventory("MarathonWeaponType", 1); }
        else if (CheckWeapon(".44 Magnum Mega Class A1") && CheckInventory("UsingDualPistols")) { SetInventory("MarathonWeaponType", 2); }
        else if (CheckWeapon(" Alien Weapon ")) { SetInventory("MarathonWeaponType", 3); }
        else if (CheckWeapon("Alien Weapon")) { SetInventory("MarathonWeaponType", 4); }
        else if (CheckWeapon("TOZT-7 Napalm Unit")) { SetInventory("MarathonWeaponType", 5); }
        else if (CheckWeapon("SPNKR-XP SSM Launcher") || CheckWeapon("ONI-71 Wave Motion Cannon")) { SetInventory("MarathonWeaponType", 6); }
        else if (CheckWeapon("WSTE-M5 Combat Shotgun") && !CheckInventory("UsingDualShotguns")) { SetInventory("MarathonWeaponType", 7); }
        else if (CheckWeapon("SPNKR-25 Auto Cannon")) { SetInventory("MarathonWeaponType", 8); }
        else if (CheckWeapon("Fusion Pistol") || CheckWeapon("Tech.50 Pacifier")) { SetInventory("MarathonWeaponType", 9); }
        else if (CheckWeapon("Steel Knuckles") || CheckWeapon("Talon Ceramic Combat Blade")) { SetInventory("MarathonWeaponType", 10); }
        else if (CheckWeapon(".44 Magnum Mega Class A1") && !CheckInventory("UsingDualPistols")) { SetInventory("MarathonWeaponType", 11); }
        else if (CheckWeapon("KKV-7 SMG Flechette")) { SetInventory("MarathonWeaponType", 12); }
        else if (!usingNotRifle) { SetInventory("MarathonWeaponType", 13); };

        Delay(1);
    }
}
